(function(){var P$=Clazz.newPackage("org.jmol.adapter.readers.xtal"),I$=[[0,'org.jmol.util.Logger','org.jmol.util.Parser','javajs.util.M3','javajs.util.PT','javajs.util.SB','javajs.util.Lst','org.jmol.api.JmolAdapter']],$I$=function(i){return I$[i]||(I$[i]=Clazz.load(I$[0][i]))};
var C$=Clazz.newClass(P$, "VaspPoscarReader", null, 'org.jmol.adapter.smarter.AtomSetCollectionReader');

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.atomLabels=null;
this.haveAtomLabels=false;
this.atomsLabeledInline=false;
this.scaleFac=0;
this.ac=0;
this.title=null;
this.quiet=false;
this.defaultLabels=null;
this.elementLabel=null;
this.radiusPt=0;
this.elementPt=0;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
this.haveAtomLabels=true;
this.radiusPt=-2147483648;
this.elementPt=-2147483648;
}, 1);

Clazz.newMeth(C$, 'initializeReader$', function () {
this.isPrimitive=true;
this.readStructure$S(null);
this.continuing=false;
});

Clazz.newMeth(C$, 'readStructure$S', function (titleMsg) {
this.title=this.rd$().trim$();
var pt=this.title.indexOf$S("--params");
if ((pt=this.title.indexOf$S$I("& ", pt + 1)) >= 0) {
this.latticeType=this.title.substring$I$I(pt + 2, pt + 3);
Clazz.load('org.jmol.util.Logger').info$S("AFLOW lattice:" + this.latticeType + " title=" + this.title );
}this.readUnitCellVectors$();
this.readMolecularFormula$();
this.readCoordinates$();
this.asc.setAtomSetName$S(this.title + (titleMsg == null  ? "" : "[" + titleMsg + "]" ));
});

Clazz.newMeth(C$, 'finalizeSubclassReader$', function () {
if (!this.haveAtomLabels && !this.atomsLabeledInline ) this.appendLoadNote$S("VASP POSCAR reader using pseudo atoms Al B C Db...");
this.finalizeReaderASCR$();
});

Clazz.newMeth(C$, 'readUnitCellVectors$', function () {
this.setSpaceGroupName$S("P1");
this.setFractionalCoordinates$Z(true);
this.scaleFac=this.parseFloatStr$S(this.rdline$().trim$());
var isVolume=(this.scaleFac < 0 );
if (isVolume) this.scaleFac=Math.pow(-this.scaleFac, 0.3333333333333333);
var unitCellData=Clazz.array(Float.TYPE, [9]);
var s=this.rdline$() + " " + this.rdline$() + " " + this.rdline$() ;
Clazz.load('org.jmol.util.Parser').parseStringInfestedFloatArray$S$javajs_util_BS$FA(s, null, unitCellData);
if (isVolume) {
var m=Clazz.load('javajs.util.M3').newA9$FA(unitCellData);
this.scaleFac /= m.determinant3$();
}if (this.scaleFac != 1 ) for (var i=0; i < unitCellData.length; i++) unitCellData[i] *= this.scaleFac;

this.addExplicitLatticeVector$I$FA$I(0, unitCellData, 0);
this.addExplicitLatticeVector$I$FA$I(1, unitCellData, 3);
this.addExplicitLatticeVector$I$FA$I(2, unitCellData, 6);
});

Clazz.newMeth(C$, 'readMolecularFormula$', function () {
if (this.elementLabel == null ) this.elementLabel=Clazz.load('javajs.util.PT').getTokens$S(this.discardLinesUntilNonBlank$());
var elementCounts;
if ($I$(4).parseInt$S(this.elementLabel[0]) == -2147483648) {
this.atomsLabeledInline=false;
elementCounts=$I$(4).getTokens$S(this.rdline$());
while (this.line != null  && (elementCounts.length == 0 || this.parseIntStr$S(elementCounts[0]) == -2147483648 ) )elementCounts=$I$(4).getTokens$S(this.rdline$());

} else {
elementCounts=this.elementLabel;
this.elementLabel=$I$(4).split$S$S(this.title, " ");
if (this.elementLabel.length != elementCounts.length || this.elementLabel[0].length$() > 2 ) {
this.elementLabel=$I$(4).split$S$S("Al B C Db Eu F Ga Hf I K Li Mn N O P Ru S Te U V W Xe Yb Zn", " ");
this.haveAtomLabels=false;
}}var labels=this.elementLabel;
var mf=Clazz.new_(Clazz.load('javajs.util.SB'));
this.atomLabels=Clazz.new_(Clazz.load('javajs.util.Lst'));
this.ac=0;
for (var i=0; i < elementCounts.length; i++) {
var n=Integer.parseInt$S(elementCounts[i]);
this.ac+=n;
var label=labels[i];
mf.append$S(" ").append$S(label).appendI$I(n);
for (var j=n; --j >= 0; ) this.atomLabels.addLast$TV(label);

}
var s=mf.toString();
if (!this.quiet) this.appendLoadNote$S(this.ac + " atoms identified for" + s );
this.asc.newAtomSet$();
this.asc.setAtomSetName$S(s);
});

Clazz.newMeth(C$, 'readCoordinates$', function () {
var isSelective=this.discardLinesUntilNonBlank$().toLowerCase$().contains$CharSequence("selective");
if (isSelective) this.rd$();
var isCartesian=(this.line.toLowerCase$().contains$CharSequence("cartesian"));
if (isCartesian) this.setFractionalCoordinates$Z(false);
for (var i=0; i < this.ac; i++) {
var radius=NaN;
var tokens=$I$(4).getTokens$S(this.rdline$());
if (this.radiusPt == -2147483648) {
for (var j=tokens.length; --j > 2; ) if (tokens[j].equals$O("radius")) {
this.radiusPt=j + 1;
} else if (this.getElement$S(tokens[j]) != null ) {
this.elementPt=j;
this.atomsLabeledInline=true;
}
}if (this.radiusPt >= 0) radius=this.parseFloatStr$S(tokens[this.radiusPt]);
var label=(this.atomsLabeledInline ? tokens[this.elementPt] : this.atomLabels.get$I(i));
if (isCartesian) for (var j=0; j < 3; j++) tokens[j]="" + new Float(this.parseFloatStr$S(tokens[j]) * this.scaleFac).toString();

var atom=this.addAtomXYZSymName$SA$I$S$S(tokens, 0, null, label);
if (!Float.isNaN$F(radius)) atom.radius=radius * this.scaleFac;
if (this.asc.bsAtoms != null ) this.asc.bsAtoms.set$I(atom.index);
}
});

Clazz.newMeth(C$, 'getElement$S', function (token) {
var s=null;
switch (token.length$()) {
default:
s=(token.length$() > 2 ? token.substring$I$I(0, 2) : null);
if (s != null  && Clazz.load('org.jmol.api.JmolAdapter').getElementNumber$S(s) >= 0 ) return s;
case 1:
if ($I$(7).getElementNumber$S(s=token.substring$I(0)) >= 0) return s;
case 0:
return null;
}
});

Clazz.newMeth(C$, 'rdline$', function () {
this.rd$();
if (this.line != null  && this.line.startsWith$S("[") ) this.line=this.line.substring$I(this.line.indexOf$S("]") + 1).trim$();
return this.line;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.2.4.05');//Created 2018-12-13 12:02:37 Java2ScriptVisitor version 3.2.4.05 net.sf.j2s.core.jar version 3.2.4.05
